// Fading LED - controlled by serial commands

int value = 0;                            
int ledpinr = 9;
int ledpinb = 10;
int ledping = 11; 

int red = 0;
int blue = 0;
int green = 0;

int startred = 0;
int startblue = 0;
int startgreen = 0;

int endred = 0;
int endblue = 0;
int endgreen = 0;

int deltared = 0;
int deltablue = 0;
int deltagreen = 0;

byte inbyte = 0;
int status = 0;

int maxv = 100;


void setColor(int red, int green, int blue){
  //Set PWM on pins 9 10 and 11
  if (red > 255){red = 255;}
  if (green > 255){green = 255;}
  if (blue > 255){blue = 255;}
  if (red < 0){red = 0;}
  if (green < 0){green = 0;}
  if (blue < 0){blue = 0;}
  analogWrite(ledpinr, 255-red);
  analogWrite(ledping, 255-green);
  analogWrite(ledpinb, 255-blue);
}

void changeColor(int endred, int endgreen, int endblue){
  deltared   = (endred - startred)/50;
  deltagreen = (endgreen - startgreen)/50;
  deltablue  = (endblue - startblue)/50;
  
  for(value = 1 ; value < 50; value+=1) 
  {        
    setColor((startred+int(deltared*value)), (startgreen+int(deltagreen*value)), (startblue+int(deltablue*value)));       
    delay(30);                           
  } 
  
  //setColor(endred, endgreen, endblue); 
  
  startred   = endred;
  startgreen = endgreen; 
  startblue  = endblue;
  
  
  delay(300);
  
}
 
void setup() 
{ 
  // geel
  startred = maxv;
  startgreen = 0; 
  startblue = 0;
  
  endred = 0;
  endgreen = 0; 
  endblue = 0;
  
  Serial.begin(9600);
  
  setColor(startred, startgreen, startblue);  // geel 
} 
 
void loop() 
{ 
  
  if (Serial.available() > 0) {
    inbyte = Serial.read();
    
    if (inbyte=='g'){
      changeColor(0,maxv,0);
      status=0;
    }
     if (inbyte=='b'){
      changeColor(0,0,maxv);
      status=0;
    }
    
    if (inbyte=='r'){
      changeColor(maxv,0,0);
      status=0;
    }
    
    if (inbyte=='y'){
      changeColor(maxv,int((maxv/10)*4),0);
      status=0;
    }
    if (inbyte=='o'){
      changeColor(0,0,0);
      status=0;
    }
    
    if (inbyte=='x'){
      status=1;
    }
    
    if (inbyte=='f'){
      changeColor(maxv,0,0);
      status=2;
    }
    
    }
    
   if (status==1){
     setColor(random(255), random(255), random(255));
     delay(100);
     
   }
   
    if (status==2){
      changeColor(0,0,maxv);
      changeColor(0,maxv,0);
      changeColor(maxv,0,0);
   }
  

} 




